/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
	"fmt"
)

// PropertyType the model 'PropertyType'
type PropertyType string

// List of PropertyType
const (
	PROPERTYTYPE_UNDEFINED PropertyType = "Undefined"
	PROPERTYTYPE_STRING    PropertyType = "String"
	PROPERTYTYPE_NUMBER    PropertyType = "Number"
	PROPERTYTYPE_BOOLEAN   PropertyType = "Boolean"
	PROPERTYTYPE_DATE_TIME PropertyType = "DateTime"
	PROPERTYTYPE_REFERENCE PropertyType = "Reference"
	PROPERTYTYPE_BINARY    PropertyType = "Binary"
	PROPERTYTYPE_OBJECT    PropertyType = "Object"
)

// All allowed values of PropertyType enum
var AllowedPropertyTypeEnumValues = []PropertyType{
	"Undefined",
	"String",
	"Number",
	"Boolean",
	"DateTime",
	"Reference",
	"Binary",
	"Object",
}

func (v *PropertyType) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := PropertyType(value)
	for _, existing := range AllowedPropertyTypeEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid PropertyType", value)
}

// NewPropertyTypeFromValue returns a pointer to a valid PropertyType
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewPropertyTypeFromValue(v string) (*PropertyType, error) {
	ev := PropertyType(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for PropertyType: valid values are %v", v, AllowedPropertyTypeEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v PropertyType) IsValid() bool {
	for _, existing := range AllowedPropertyTypeEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to PropertyType value
func (v PropertyType) Ptr() *PropertyType {
	return &v
}

type NullablePropertyType struct {
	value *PropertyType
	isSet bool
}

func (v NullablePropertyType) Get() *PropertyType {
	return v.value
}

func (v *NullablePropertyType) Set(val *PropertyType) {
	v.value = val
	v.isSet = true
}

func (v NullablePropertyType) IsSet() bool {
	return v.isSet
}

func (v *NullablePropertyType) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePropertyType(val *PropertyType) *NullablePropertyType {
	return &NullablePropertyType{value: val, isSet: true}
}

func (v NullablePropertyType) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePropertyType) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
